// JavaScript Document
function CcarSFX(game){
	this.effects=new Array();

	this.addEffect=addEffect;function addEffect(type,lane){
		var effect={
			"type":type,
			"lane":lane,
			"startTime":game.time,
			"position":game.cars[lane].car.drawPosition,
			"trackPos":game.trackPos,
			"frames":4
		}
		var brrumm=0.2;
		switch(type){
			case('fire_1'):
				brrumm=0;
				break;
			case('fire_2'):
				brrumm=0.8;
				break;
			case('smoke_2'):effect.frames=6;break;
			default:effect.ln=4;break;
		}
		if(Math.random()<brrumm){
			brrumm=Math.floor(Math.random()*2);
			brrumm='engine'+brrumm;
			if(game.assets.Data.Sounds[brrumm])game.assets.Data.Sounds[brrumm].Play();
		}
		this.effects.push(effect);
	}
	
	this.carMoves=carMoves;function carMoves(lane){
		var effChance=0.3;
		var effects=['smoke_2','fire_2','tires'];
		if(Math.random()<effChance){
			var eff=Math.floor(Math.random()*effects.length);
			this.addEffect(effects[eff],lane);
		}
	}
	
	this.Run=Run;function Run(lane){
		if(!game.UI)return;
		var ctx=game.UI.raceCtx;
		if(!ctx)return;
		for(i=0;i<this.effects.length;i++)if(this.effects[i].lane==lane)this.runEffect(this.effects[i],i);
	}
	
	this.runEffect=runEffect;function runEffect(effect,index){
		var runtime=1000;
		var remove=true;
		var delta,carD,frame;
		var perc=(game.time-effect.startTime)/runtime;
		if(perc<1)
			frame=Math.floor(perc*effect.frames)+1;
		else
			frame=1;
		var img=game.assets.Data.Images[effect.type+'_'+frame];
		var car=game.assets.Data.Images['carImg_'+game.cars[effect.lane].car.carType+'_0'];
		switch(effect.type){
			case('fire_1'):
				delta=[img.width,0];
				carD=game.config.gameSettings.cars[game.cars[effect.lane].car.carType].hoodEff;
				effect.position=game.cars[effect.lane].car.drawPosition;
				remove=false;
				break;
			case('fire_2'):
				delta=[car.width*0.5+img.width-20,car.height*0.5-img.height+20];
				carD=game.config.gameSettings.cars[game.cars[effect.lane].car.carType].behindEff;
				effect.position=game.cars[effect.lane].car.drawPosition;
				break;
			case('smoke_1'):
//				delta=[car.width*0.5+img.width,car.height*0.5-img.height];
				delta=[img.width*1.7,img.height/2];
				carD=game.config.gameSettings.cars[game.cars[effect.lane].car.carType].hoodEff;
				effect.position=game.cars[effect.lane].car.drawPosition;
				remove=false;
				if(game.time-effect.startTime>runtime)effect.startTime+=runtime/2;
				break;
			case('smoke_2'):
				delta=[car.width*0.5+img.width,car.height*0.5-img.height];
				carD=game.config.gameSettings.cars[game.cars[effect.lane].car.carType].behindEff;
				effect.position=game.cars[effect.lane].car.drawPosition;
				break;
			default://tiremark
				runtime=300;
				if(game.time-effect.startTime>runtime){
					effect.startTime-=runtime;
					frame=effect.frames;
					img=game.assets.Data.Images[effect.type+'_'+frame];
				}
				delta=[car.width*0.25+img.width+game.trackPos-effect.trackPos,car.height*0.5-img.height+15];
				carD=game.config.gameSettings.cars[game.cars[effect.lane].car.carType].tireEff;
				remove=false;
				break;
		}
		if(game.time-effect.startTime>runtime){
			if(remove || delta[0]>900){
				this.effects.splice(index,1);
				return;
			}else{
				effect.startTime+=runtime;
			}
		}
		var X=200+effect.position;
		X-=game.trackPan+delta[0];
		var Y=273+effect.lane*52+delta[1];
		X+=carD[0];
		Y+=carD[1];
		drawPic(img,X,Y,1.0,game.UI.raceCtx,game.UI.scaleVal);
	}
}